function [ LWD, JamInd, Nkey ] = Jam_ID( LWD, W_ch, HLcrit, year)
%this function identifies and labels all of the jams in the reach

        %identify all of the jams that remain in the system, based on the
        %criteria that the key piece blocks 90% of the channel
        JamInd = find(LWD(:,1) .* sind(LWD(:,4)) > (HLcrit./100) .* W_ch);
        
        Nkey = sum(LWD(JamInd,8));              %calculate total number of key pieces that can form jams, weighted by the wood function
        NKP =numel(JamInd);
       
        %do the following only if there are key pieces in the system and
        %the jam
        %formation flag is turned on
        if isempty(JamInd) == 0 
            %set the LWD Key piece flag
            %LWD(JamInd,7) = 1;
        
            %%%%%%%%%set or modify the jam age class for each jam%%%%%%%%%%%%
            for NJi = 1:NKP
                if LWD(JamInd(NJi),3) < 10
                    LWD(JamInd(NJi),7) = 4;
                elseif LWD(JamInd(NJi),3) >= 10 && LWD(JamInd(NJi),3) < 20
                    LWD(JamInd(NJi),7) = 3;
                elseif LWD(JamInd(NJi),3) >= 20 && LWD(JamInd(NJi),3) < 50
                    LWD(JamInd(NJi),7) = 2;
                else
                    LWD(JamInd(NJi),7) = 1;
                end
                
                if LWD(JamInd(NJi),6) == 0
                    LWD(JamInd(NJi),6) = year + 0.001 .* NJi;
                end
            end
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
        end

end

